<?php
namespace Teknisa\CDP\Controllers;

use Teknisa\CDP\Controllers\TeknisaCrud;
use Doctrine\ORM\EntityManager;
use Teknisa\GER\Controllers\CrudController;
use Zeedhi\Framework\DataSource\ParameterBag;
use \Teknisa\GER\Libraries\PHPMailer;
use \Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO;

use Teknisa\GER\Services\CrudService;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request\Row;
use Teknisa\CDP\Services\qpr01900InspecaoDigitalService;

class qpr01900InspecaoDigitalController extends TeknisaCrud {

    protected $dataSourceName = 'inspecaoquestao';
    protected $dataSourceNameToSave = '';
    protected $service; 
    protected $parameterBag;
    protected $entityManager;
    
    public function __construct($crudService, ParameterBag $parameterBag, EntityManager $entityManager, qpr01900InspecaoDigitalService $service)
    {        
        $this->service = $service;
        $this->entityManager = $entityManager;
        $this->qpr01900InspecaoDigitalService = $service;
        parent::__construct($crudService, $parameterBag);
    }
    
    public function getNrOrg(Row $request, Response $response) {
        $nrorg = $this->service->getNrOrg();
        return $nrorg;
    }
    
    public function changeQuestion(Row $request, Response $response) {
        $row  = $request->getRow();
        if ($row['TPQUESTCHECK'] == 'VIS') {
            unset($row['TPQUESTCHECK']);
            var_dump($row);
            if($row['IDSITQUESTAROP'] == 3) {
                $row['IDSITQUESTAROP'] = 2;
            } else {
                $row['IDSITQUESTAROP'] = 3;
            }
            $row['__is_new'] = false;
            $dataSet = new DataSet($this->dataSourceName, array($row));
            $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            parent::save($requestSalvar, $response);
        }
    }
    
    public function searchTarefaQuestao(Row $request, Response $response) {
        $this->dataSourceName = 'inspecaoquestao';
        $row = $request->getRow();
        try {
            $x = $this->service->searchTarefaQuestao($row);
            $dataset = new DataSet('resultados', $x);
            $response->setDataSets(array($dataset));
        } catch (\Exception $e) {
            if(!(count($response->getError()))) {
                $response->setError(new Error("Error in data search. ". $e->getMessage(), 500));
            }
        }
    }
    
    public function sendChanges(Row $request, Response $response) {
        $this->dataSourceName = 'questtarop';
        $row = $request->getRow();
        try {
            foreach($row[0] as $questao) {
                $dataSet = new DataSet($this->dataSourceName, array($questao));
                $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                parent::save($requestSalvar, $response);
            }
            $this->dataSourceName = 'resptarvisbo';
            foreach($row[1] as $respVisBo) {
                $dataSet = new DataSet($this->dataSourceName, array($respVisBo));
                $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                parent::save($requestSalvar, $response);
            }
            $this->dataSourceName = 'restarvr';
            foreach($row[2] as $respVal) {
                $dataSet = new DataSet($this->dataSourceName, array($respVal));
                $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                parent::save($requestSalvar, $response);
            }
            $this->dataSourceName = 'respcadtar';
            foreach($row[3] as $respCad) {
                $dataSet = new DataSet($this->dataSourceName, array($respCad));
                $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                parent::save($requestSalvar, $response);
            }
            foreach($row[4] as $respCadDel) {
                $dataSet = new DataSet($this->dataSourceName, array($respCadDel));
                $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                parent::delete($requestSalvar, $response);
            }
            $this->dataSourceName = 'tarefacheckop';
            foreach($row[5] as $tarefa) {
                $dataSet = new DataSet($this->dataSourceName, array($tarefa));
                $requestSalvar = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                parent::save($requestSalvar, $response);
            }
        } catch (\Exception $e) {
            if(!(count($response->getError()))) {
                $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            }
        }
        
    }

}