<?php
namespace Teknisa\CDP\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Pedidosexpedicao\Entities\Precobase;
use Teknisa\Model\Pedidosexpedicao\Entities\Promoprbase;
use Teknisa\Model\Pedidosexpedicao\Entities\Opcioprbase;
use Teknisa\Model\Pedidosexpedicao\Entities\Itemprebase;
use Teknisa\Model\Eventos\Entities\Prbaseconvidaore;

class qpr01900InspecaoDigitalFactory {
    
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection       = $entityManager->getConnection();
        $this->entityManager    = $entityManager;
    }

    public function searchAllTables($NRORG) {
        $sql = "SELECT A.DTAGEVENDREGIAO, R.NRCORREGIAOPED FROM AGENDAVENDEDOR A
                JOIN REGIAOPED R ON A.CDREGIAOPED = R.CDREGIAOPED AND A.CDVENDEDOR = :CDVENDEDOR AND A.NRORG = :NRORG";
        
        $params = array();
        $params['nrorg'] = $NRORG;
        $params['cdvendedor'] = $CDVENDEDOR;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
    
    
    public function searchInspecaoTarefa($NRORG, $CDOPERADOR, $DATAINICIO, $DATAFINAL) {
        $sql = "SELECT * FROM(SELECT ETAPAPROD.NMETAPAPROD , PRODUTO.NMPRODUTO , HABILOPER.CDOPERADOR AS CDOPER,
        PRODUTO.CDARVPROD , CHECKLIST.DSCHECKLIST , ORDPRODUCAO.NRORDPROD , ORDPRODUCAO.NRLOTEESTQ , 
        ORDPRODUCAO.NRSUBLOTE , ORDPRODUCAO.CDPRODUTO , ORDPRODUCAO.DTGERORDPROD AS LANCAMENTO, 
        INSPECAO.NMINSPECAO , INSPECAUDIT.DTINIPINSAUD , TAREFACHECKOP.CDFILIAL , 
        TAREFACHECKOP.NRSUBORDPROD , TAREFACHECKOP.CDETAPAPROD , 
        TAREFACHECKOP.CDCHECKLIST , TAREFACHECKOP.CDINSPECAO , TAREFACHECKOP.CDHABILIDADE , 
        TAREFACHECKOP.NRAUDITORIA , TAREFACHECKOP.NRINSPECAUDI , TAREFACHECKOP.DTHRINICHECK , 
        TAREFACHECKOP.DTHRFIMCHECK , TAREFACHECKOP.CDOPERADOR , TAREFACHECKOP.OBSCHECKOP , 
        TAREFACHECKOP.IDSITTARCHECKOP, TAREFACHECKOP.NRORG , TAREFACHECKOP.IDATIVO , TAREFACHECKOP.DTINCLUSAO , 
        TAREFACHECKOP.DTULTATU , TAREFACHECKOP.NRORGINCLUSAO , TAREFACHECKOP.CDOPERINCLUSAO , TAREFACHECKOP.NRORGULTATU , 
        TAREFACHECKOP.CDOPERULTATU FROM TAREFACHECKOP, ORDPRODUCAO , INSPECAUDIT , ETAPAPROD , CHECKLIST , HABILOPER , INSPECAO , 
        PRODUTO WHERE TAREFACHECKOP.CDCHECKLIST = CHECKLIST.CDCHECKLIST AND TAREFACHECKOP.CDETAPAPROD = ETAPAPROD.CDETAPAPROD AND 
        TAREFACHECKOP.CDINSPECAO = INSPECAO.CDINSPECAO AND TAREFACHECKOP.CDFILIAL = ORDPRODUCAO.CDFILIAL AND TAREFACHECKOP.NRORDPROD = 
        ORDPRODUCAO.NRORDPROD AND TAREFACHECKOP.NRSUBORDPROD = ORDPRODUCAO.NRSUBORDPROD AND TAREFACHECKOP.CDHABILIDADE = HABILOPER.CDHABILIDADE 
        AND TAREFACHECKOP.CDINSPECAO = INSPECAUDIT.CDINSPECAO AND TAREFACHECKOP.NRAUDITORIA = INSPECAUDIT.NRAUDITORIA AND 
        TAREFACHECKOP.NRINSPECAUDI = INSPECAUDIT.NRINSPECAUDI AND ORDPRODUCAO.CDPRODUTO = PRODUTO.CDPRODUTO
        AND HABILOPER.CDOPERADOR = :CDOPERADOR AND (DTGERORDPROD BETWEEN :DATAINICIO AND :DATAFINAL) 
        AND TAREFACHECKOP.NRORG = :NRORG ORDER BY CDCHECKLIST, NRORDPROD)TAREFACHECKOP";
        
        $params = array();
        $params['nrorg'] = $NRORG;
        $params['cdoperador'] = $CDOPERADOR;
        $params['datainicio'] = $DATAINICIO;
        $params['datafinal'] = $DATAFINAL;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function searchInspecaoQuestao($NRORG) {
        $sql = "SELECT QUESTTAROP.NRQUESTCHECK, QUESTTAROP.IDSITQUESTAROP, QUESTCHECK.DSQUESTCHECK, 
        QUESTCHECK.TPQUESTCHECK, QUESTTAROP.CDFILIAL, QUESTTAROP.NRORDPROD, QUESTTAROP.NRSUBORDPROD, 
        QUESTTAROP.CDETAPAPROD, QUESTTAROP.CDCHECKLIST, QUESTTAROP.CDINSPECAO, QUESTTAROP.CDHABILIDADE,
        QUESTTAROP.NRAUDITORIA, QUESTTAROP.NRINSPECAUDI, QUESTTAROP.OBSCHECKOP, QUESTTAROP.NRORG, 
        QUESTTAROP.IDATIVO, QUESTTAROP.DTINCLUSAO, QUESTTAROP.DTULTATU, QUESTTAROP.NRORGINCLUSAO, 
        QUESTTAROP.CDOPERINCLUSAO, QUESTTAROP.NRORGULTATU, QUESTTAROP.CDOPERULTATU FROM QUESTCHECK, 
        QUESTTAROP WHERE QUESTCHECK.CDCHECKLIST = QUESTTAROP.CDCHECKLIST AND QUESTCHECK.NRQUESTCHECK = 
        QUESTTAROP.NRQUESTCHECK AND QUESTTAROP.NRORG = :NRORG ORDER BY NRQUESTCHECK";
        
        $params = array();
        $params['nrorg'] = $NRORG;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
    
    public function searchInspecaoQuestaoParam($NRORG, $CDCHECKLIST, $NRORDPROD, $NRSUBORDPROD, $CDINSPECAO, $NRAUDITORIA) {
        $sql = "SELECT QUESTTAROP.NRQUESTCHECK, QUESTTAROP.IDSITQUESTAROP, QUESTCHECK.DSQUESTCHECK, 
        QUESTCHECK.TPQUESTCHECK, QUESTTAROP.CDFILIAL, QUESTTAROP.NRORDPROD, QUESTTAROP.NRSUBORDPROD, 
        QUESTTAROP.CDETAPAPROD, QUESTTAROP.CDCHECKLIST, QUESTTAROP.CDINSPECAO, QUESTTAROP.CDHABILIDADE,
        QUESTTAROP.NRAUDITORIA, QUESTTAROP.NRINSPECAUDI, QUESTTAROP.OBSCHECKOP, QUESTTAROP.NRORG, 
        QUESTTAROP.IDATIVO, QUESTTAROP.DTINCLUSAO, QUESTTAROP.DTULTATU, QUESTTAROP.NRORGINCLUSAO, 
        QUESTTAROP.CDOPERINCLUSAO, QUESTTAROP.NRORGULTATU, QUESTTAROP.CDOPERULTATU FROM QUESTCHECK, 
        QUESTTAROP WHERE QUESTCHECK.CDCHECKLIST = QUESTTAROP.CDCHECKLIST AND QUESTCHECK.NRQUESTCHECK = 
        QUESTTAROP.NRQUESTCHECK AND QUESTTAROP.CDCHECKLIST = :CDCHECKLIST AND QUESTTAROP.NRORDPROD = :NRORDPROD 
        AND QUESTTAROP.NRSUBORDPROD = :NRSUBORDPROD AND QUESTTAROP.CDINSPECAO = :CDINSPECAO 
        AND QUESTTAROP.NRAUDITORIA = :NRAUDITORIA AND QUESTTAROP.NRORG = :NRORG ORDER BY NRQUESTCHECK";
        
        $params = array();
        $params['nrorg'] = $NRORG;
        $params['cdchecklist'] = $CDCHECKLIST;
        $params['nrordprod'] = $NRORDPROD;
        $params['nrsubordprod'] = $NRSUBORDPROD;
        $params['cdinspecao'] = $CDINSPECAO;
        $params['nrauditoria'] = $NRAUDITORIA;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
    
    public function searchRespVal($NRORG, $CDCHECKLIST) {
        $sql = 'SELECT * FROM RESPVRCHECK WHERE NRORG = :NRORG AND CDCHECKLIST = :CDCHECKLIST';
        
        $params = array();
        $params['nrorg'] = $NRORG;
        $params['cdchecklist'] = $CDCHECKLIST;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
    
    public function searchRespBool($NRORG, $CDCHECKLIST) {
        $sql = 'SELECT * FROM RESPBOVISCHECK WHERE NRORG = :NRORG AND CDCHECKLIST = :CDCHECKLIST';
        
        $params = array();
        $params['nrorg'] = $NRORG;
        $params['cdchecklist'] = $CDCHECKLIST;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
    
    public function searchRespCad($NRORG, $CDCHECKLIST) {
        $sql = 'SELECT * FROM CADRESPCHECK WHERE NRORG = :NRORG AND CDCHECKLIST = :CDCHECKLIST';
        
        $params = array();
        $params['nrorg'] = $NRORG;
        $params['cdchecklist'] = $CDCHECKLIST;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
    
    public function searchVisBooQuestResp($NRORG, $CDCHECKLIST) {
        $sql = 'SELECT * FROM RESPTARVISBO WHERE NRORG = :NRORG AND CDCHECKLIST = :CDCHECKLIST';
        
        $params = array();
        $params['nrorg'] = $NRORG;
        $params['cdchecklist'] = $CDCHECKLIST;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
    
    public function searchVarQuestResp($NRORG, $CDCHECKLIST) {
        $sql = 'SELECT * FROM RESTARVR WHERE NRORG = :NRORG AND CDCHECKLIST = :CDCHECKLIST';
        
        $params = array();
        $params['nrorg'] = $NRORG;
        $params['cdchecklist'] = $CDCHECKLIST;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
    
    public function searchCadQuestResp($NRORG, $CDCHECKLIST) {
        $sql = 'SELECT R.CDFILIAL, R.CDETAPAPROD, R.CDCHECKLIST, R.CDINSPECAO, 
        R.NRQUESTCHECK, R.NRORDPROD, R.NRSUBORDPROD, R.CDHABILIDADE, R.NRAUDITORIA,
        R.NRINSPECAUDI, R.CDRESPCAD, R.CDPRODUTO, P.NMPRODUTO, R.CDEQUIPPRO, E.NMEQUIPPRO, 
        R.NRLOTEESTQ,R.CDOPERADOR, O.NMOPERADOR, R.COL1, R.COL2, R.COL3, R.COL4, R.COL5, 
        R.COL6, R.COL7, R.COL8, R.COL9, R.NRORG 
        FROM RESPCADTAR R, PRODUTO P, EQUIPAPROD E, OPERADOR O
        WHERE R.NRORG = :NRORG AND R.CDCHECKLIST = :CDCHECKLIST
        AND P.CDPRODUTO (+)= R.CDPRODUTO
        AND E.CDEQUIPPRO (+)= R.CDEQUIPPRO 
        AND O.CDOPERADOR (+)= R.CDOPERADOR ';
        
        $params = array();
        $params['nrorg'] = $NRORG;
        $params['cdchecklist'] = $CDCHECKLIST;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
}

?>