<?php
namespace Teknisa\CDP\Modules\Producao\Controllers;

    use \Teknisa\GER\Libraries\PHPMailer;
    use Teknisa\GER\Controllers\CrudController;
    use Zeedhi\Framework\DTO;
    use Zeedhi\Framework\DTO\Response\Error;
    use \Zeedhi\Framework\DataSource\DataSet;
    use Zeedhi\Framework\DataSource\ParameterBag;

    class Cdp04000AgendaDeTarefasController extends \Teknisa\CDP\Controllers\TeknisaCrud {
        protected $dataSourceName = 'agentare';
        protected $dataSourceNameToSave = '';
        protected $Cdp04000AgendaDeTarefasService;
  
        public function __construct($crudService, ParameterBag $parameterBag, $Cdp04000AgendaDeTarefasService){
            parent::__construct($crudService, $parameterBag);
            $this->Cdp04000AgendaDeTarefasService = $Cdp04000AgendaDeTarefasService;
        }

        public function deletarAgenda(DTO\Request $request, DTO\Response $response){
            try {
                $rows = $request->getRow();
                $this->Cdp04000AgendaDeTarefasService->deleteAgenda($rows);
            } catch (\Exception $e) {
                $response->setError(new Error($e->getMessage(), 500));
            }
        }
        
        public function saveAgenda(DTO\Request $request, DTO\Response $response) {
            $row = $request->getRow();
    	    
    	    var_dump($request);
    	    try{
    	        if(!$row['__is_new']) {
    	            $this->Cdp04000AgendaDeTarefasService->UpdateAgenda($row);
        	    } else {
        	        parent::save($request, $response);
        	    }
    	    } catch(\Exception $e){
    	        $response->setError(new DTO\Response\Error($e->getMessage(),1));
    	    }
	    }
	    
	    public function verificaInspecao(DTO\Request $request, DTO\Response $response) {
            $row = $request->getRow();
    	    try{
                $this->Cdp04000AgendaDeTarefasService->verificaInspec($row);
    	    } catch (\Exception $e){
                $response->setError(new Error($e->getMessage(), $e->getCode()));
            }
	    }
        
    }
?>