<?php
namespace Teknisa\CDP\Modules\Producao\Controllers;

    use Teknisa\CDP\Controllers\TeknisaCrud;
    use Teknisa\CDP\Controllers\CrudController;
    use Zeedhi\Framework\DTO;
    use Zeedhi\Framework\DTO\Response\Error;
    use \Zeedhi\Framework\DataSource\DataSet;
    use Zeedhi\Framework\DataSource\ParameterBag;

    class Cdp07700CalendarioDeProducaoController extends TeknisaCrud {
        protected $dataSourceName = 'caleproducao';
        protected $dataSourceNameToSave = '';
        protected $Cdp07700CalendarioDeProducaoService;
  
        public function __construct($crudService, ParameterBag $parameterBag, $Cdp07700CalendarioDeProducaoService){
            parent::__construct($crudService, $parameterBag);
            $this->Cdp07700CalendarioDeProducaoService = $Cdp07700CalendarioDeProducaoService;
        }

        public function deletarCalendarioProducao(DTO\Request $request, DTO\Response $response){
            try {
                $rows = $request->getRow();
                $this->Cdp07700CalendarioDeProducaoService->deleteCalendario($rows);
            } catch (\Exception $e) {
                $response->setError(new Error($e->getMessage(), 500));
            }
        }
        
        public function deletarCalendarioProducaoMes(DTO\Request $request, DTO\Response $response){
            try {
                $rows = $request->getRow();
                $this->Cdp07700CalendarioDeProducaoService->deleteCalendarioMes($rows);
            } catch (\Exception $e) {
                $response->setError(new Error($e->getMessage(), 500));
            }
        }
        
        
        public function CalculoProducaoAnual(DTO\Request $request, DTO\Response $response) {
            try {
                $rows = $request->getRow();
                $this->Cdp07700CalendarioDeProducaoService->CalcularProducaoAnual($rows, $response);
            } catch (\Exception $e) {
                $response->setError(new Error($e->getMessage(), 500));
            }
        }

    }
    
    
?>