<?php
namespace Teknisa\CDP\Modules\Producao\Factories;

use Doctrine\ORM\EntityManager;

class ger24000HabilidadeFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection       = $entityManager->getConnection();
        $this->entityManager    = $entityManager;
    }

    public function insertCustohab($params){
        $sql = "INSERT INTO CUSTOHAB (CDHABILIDADE, CDCUSTOHAB, DSCUSTOHAB, VRCUSTOHAB, CDCONTCTBLHAB, NRORG)
                VALUES (:CDHABILIDADE,
                        :CDCUSTOHAB,
                        :DSCUSTOHAB,
                        :VRCUSTOHAB,
                        :CDCONTCTBLHAB,
                        :NRORG)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function updateCustohab($params){
        $sql = "UPDATE CUSTOHAB
                SET DSCUSTOHAB = :DSCUSTOHAB,
                    VRCUSTOHAB = :VRCUSTOHAB,
                    CDCONTCTBLHAB = :CDCONTCTBLHAB
                WHERE CDHABILIDADE = :CDHABILIDADE
                  AND CDCUSTOHAB = :CDCUSTOHAB
                  AND NRORG = :NRORG";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function updateHabilidade($params){
        $sql = "UPDATE HABILIDADE
                SET VRCUSHRHABIL = :VRCUSHRHABIL
                WHERE CDHABILIDADE = :CDHABILIDADE
                  AND NRORG = :NRORG";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
}