<?php
namespace Teknisa\CDP\Modules\Producao\Services;

use Doctrine\ORM\EntityManager;
use Geral\Util\DateUtil;
use Teknisa\Libs\Util\Environment;


class Cdp01100TarefaService{

	protected $entityManager;
	protected $environment;
	protected $newCode;
	protected $Cdp01100TarefaFactory;

	public function __construct(Environment $environment, EntityManager $entityManager, $Cdp01100TarefaFactory){
		$this->environment				= $environment;
		$this->entityManager           = $entityManager;
		$this->Cdp01100TarefaFactory = $Cdp01100TarefaFactory;
	}

	
    public function verificaPai($rows){
        try{
        	$connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            if($rows['CDARVINSPECANTE'] == NULL){
                $existeNaTabela = $this->Cdp01100TarefaFactory->verificaCDARVINSPEC($rows['CDARVINSPEC']);
                
                if($existeNaTabela){
                    if($existeNaTabela["0"]["IDORIGINSPEC"] == 'QUA'){
                        throw new \Exception('O código '.$rows['CDARVINSPEC'].' já existe na tela de Inspeção');
                    } else if($existeNaTabela["0"]["IDORIGINSPEC"] == 'ANA'){
                        throw new \Exception('O código '.$rows['CDARVINSPEC'].' já existe na tela de Análise');
                    } else if($existeNaTabela["0"]["IDORIGINSPEC"] == 'TAR'){
                        throw new \Exception('O código '.$rows['CDARVINSPEC'].' já existe na tela de Tarefa');
                    }
                }
                
            } 
            else if($rows['CDARVINSPECANTE'] >= 0){
                $existePai = $this->Cdp01100TarefaFactory->verificaCDARVINSPECANTE($rows['CDARVINSPECANTE']);
                
                if($existePai){
                    $existeNaTabela = $this->Cdp01100TarefaFactory->verificaCDARVINSPEC($rows['CDARVINSPEC']);
                    if($existeNaTabela){    
                        if($existeNaTabela["0"]["IDORIGINSPEC"] == 'QUA'){
                            throw new \Exception('O código '.$rows['CDARVINSPEC'].' já existe na tela de Inspeção');
                        } else if($existeNaTabela["0"]["IDORIGINSPEC"] == 'ANA'){
                            throw new \Exception('O código '.$rows['CDARVINSPEC'].' já existe na tela de Análise');
                        } else if($existeNaTabela["0"]["IDORIGINSPEC"] == 'TAR'){
                            throw new \Exception('O código '.$rows['CDARVINSPEC'].' já existe na tela de Tarefa');
                        }
                    }
                } 
                else {
                    throw new \Exception('O código '.$rows['CDARVINSPEC'].' não possui pai. Cadastre o código '.$rows['CDARVINSPECANTE'].' na àrvore de tarefas antes de cadastrar o código '.$rows['CDARVINSPEC'].'.');
                }
            }
            
        } catch (\Exception $e) {
	        $this->entityManager->rollback();
	        throw $e;
	    }
    }
    
    public function verificaDelete($rows){
        try{
        	$connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            $existeFilho = $this->Cdp01100TarefaFactory->verificaDelete($rows['CDARVINSPEC']);
            if($existeFilho[0]["TEM_FILHO"] != 0){
                throw new \Exception('O código '.$rows['CDARVINSPEC'].' possui ' .$existeFilho[0]["TEM_FILHO"].' filho(s). Delete-o(s) se deseja deletar este código.');
            } else {
                $this->Cdp01100TarefaFactory->deleteArv($rows['NRORG'], $rows['CDARVINSPEC'], $rows['CDINSPECAO']);
            }
        } catch (\Exception $e) {
	        $this->entityManager->rollback();
	        throw $e;
	    }
    }
    
    public function updateTarefaDesc($rows){
        try{
        	
            $this->Cdp01100TarefaFactory->updateTarefaDesc($rows['NRORG'], $rows['CDINSPECAO'], $rows['TXDESCINSPEC'], $rows['TXDESCINSPEC_CLOB']);
        
        } catch (\Exception $e) {
	        $this->entityManager->rollback();
	        throw $e;
	    }
    }
    
}
