<?php
namespace Teknisa\CDP\Modules\Producao\Services;

use Doctrine\ORM\EntityManager;
use Geral\Util\DateUtil;
use Teknisa\Libs\Util\Environment;


class Ger11800InspecaoService{

	protected $entityManager;
	protected $environment;
	protected $newCode;
	protected $Ger11800InspecaoFactory;

	public function __construct(Environment $environment, EntityManager $entityManager, $Ger11800InspecaoFactory){
		$this->environment				= $environment;
		$this->entityManager           = $entityManager;
		$this->Ger11800InspecaoFactory = $Ger11800InspecaoFactory;
	}

	
    public function verificaPai($rows){
        try{
        	$connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            if($rows['CDARVINSPECANTE'] == NULL){
                $existeNaTabela = $this->Ger11800InspecaoFactory->verificaCDARVINSPEC($rows['CDARVINSPEC']);
                if($existeNaTabela){
                    if($existeNaTabela["0"]["IDORIGINSPEC"] == 'QUA'){
                        throw new \Exception('O código '.$rows['CDARVINSPEC'].' já existe na tela de Inspeção');
                    } else if($existeNaTabela["0"]["IDORIGINSPEC"] == 'ANA'){
                        throw new \Exception('O código '.$rows['CDARVINSPEC'].' já existe na tela de Análise');
                    } else if($existeNaTabela["0"]["IDORIGINSPEC"] == 'TAR'){
                        throw new \Exception('O código '.$rows['CDARVINSPEC'].' já existe na tela de Tarefa');
                    }
                }
            } else if($rows['CDARVINSPECANTE'] >= 0){
                $existePai = $this->Ger11800InspecaoFactory->verificaCDARVINSPECANTE($rows['CDARVINSPECANTE']);
                if($existePai){
                    $existeNaTabela = $this->Ger11800InspecaoFactory->verificaCDARVINSPEC($rows['CDARVINSPEC']);
                    if($existeNaTabela){
                        if($existeNaTabela["0"]["IDORIGINSPEC"] == 'QUA'){
                            throw new \Exception('O código '.$rows['CDARVINSPEC'].' já existe na tela de Inspeção');
                        } else if($existeNaTabela["0"]["IDORIGINSPEC"] == 'ANA'){
                            throw new \Exception('O código '.$rows['CDARVINSPEC'].' já existe na tela de Análise');
                        } else if($existeNaTabela["0"]["IDORIGINSPEC"] == 'TAR'){
                            throw new \Exception('O código '.$rows['CDARVINSPEC'].' já existe na tela de Tarefa');
                        }
                    }
                } else {
                    throw new \Exception('O código '.$rows['CDARVINSPEC'].' não possui pai. Cadastre o código '.$rows['CDARVINSPECANTE'].' na àrvore de tarefas antes de cadastrar o código '.$rows['CDARVINSPEC'].'.');
                }
            }
        } catch (\Exception $e) {
	        $this->entityManager->rollback();
	        throw $e;
	    }
    }
    
    public function verificaDelete($rows){
        try{
        	$connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            $existeFilho = $this->Ger11800InspecaoFactory->verificaDelete($rows['CDARVINSPEC']);
            if($existeFilho[0]["TEM_FILHO"] != 0){
                throw new \Exception('O código '.$rows['CDARVINSPEC'].' possui ' .$existeFilho[0]["TEM_FILHO"].' filho(s). Delete-o(s) se deseja deletar este código.');
            } else {
                $existeCDINSPECAO = $this->Ger11800InspecaoFactory->verificaDeleteCDINSPECAO($rows['CDINSPECAO']);
                if ($existeCDINSPECAO) {
                    throw new \Exception('Restrição de integridade violada - registo filho encontrado');
                } else {
                    $this->Ger11800InspecaoFactory->deleteArv($rows['NRORG'], $rows['CDARVINSPEC'], $rows['CDINSPECAO']);
                }
            }
        } catch (\Exception $e) {
	        $this->entityManager->rollback();
	        throw $e;
	    }
    }
    
    public function updateDesc($rows){
        try{
        	
            $this->Ger11800InspecaoFactory->updateDesc($rows['NRORG'], $rows['CDINSPECAO'], $rows['TXDESCINSPEC'], $rows['TXDESCINSPEC_CLOB']);
        
        } catch (\Exception $e) {
	        $this->entityManager->rollback();
	        throw $e;
	    }
    }
    
}