<?php
namespace Teknisa\CDP\Modules\Producao\Services;

use Doctrine\ORM\EntityManager;
use Geral\Util\DateUtil;
use \Teknisa\Libs\Util\Environment;


class ger55000InformacoesAdicionaisService {

	protected $entityManager;
	protected $environment;
	protected $newCode;
	protected $ger55000InformacoesAdicionaisFactory;

	public function __construct(Environment $environment, EntityManager $entityManager, $ger55000InformacoesAdicionaisFactory){
		$this->environment				= $environment;
		$this->entityManager           = $entityManager;
		$this->ger55000InformacoesAdicionaisFactory = $ger55000InformacoesAdicionaisFactory;
	}

	
    public function saveInfo($rows){
    	$connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
        try{
            $this->saveInfoAdicional($rows);
            $this->entityManager->flush();
	    	$this->saveInfoProduto($rows);
	    	$this->entityManager->flush();
            $connection->commit();
	    	$message = "Operações realizadas com sucesso";
	    	return $message;
        }catch (\Exception $e) {
            $connection->rollBack();
            throw $e;
        }
    	
    }
    
    public function saveInfoAdicional($rows){
        try{
        	$params = array(
        		'CDPRODUTO'=>$rows['CDPRODUTO'],
            	'NRORG'=>$this->environment->getNrOrgTrab()
        	);
        	$newRow = $this->ger55000InformacoesAdicionaisFactory->selectInfadicprod($params);
        	
        	$newRow = $newRow[0]['COUNT(CDPRODUTO)'];
        	
        	$params = array(
        		'CDPRODUTO'=>$rows['CDPRODUTO'], 
        		'CDEANPROD'=>$rows['CDEANPROD'], 
        		'CDDUNPROD'=>$rows['CDDUNPROD'],
            	'NRORG'=>$this->environment->getNrOrgTrab()
        	);
        	return $this->ger55000InformacoesAdicionaisFactory->saveInfo($params, $newRow);
        }catch (\Exception $e) {
	        throw $e;
	    }
    }
    
    public function saveInfoProduto($rows){
        try{
        	$params = array(
        		'CDGGREM'=>$rows['CDGGREM'], 
        		'CDPRODUTO'=>$rows['CDPRODUTO'], 
            	'NRORG'=>$this->environment->getNrOrgTrab()
        	);
        	return $this->ger55000InformacoesAdicionaisFactory->saveProduto($params);
        }catch (\Exception $e) {
	        throw $e;
	    }
    }


}

?>