<?php
namespace Geral\Logic\Pedido;
use Geral\Util\Ambiente;
use Geral\Util\DateUtil;
use Pedidos\Entities\Obspedido;
use Setforms2\Shared\Registry;

class OperacaoObsPedido{

    //Registra Observacao do Pedido
    public static function regObsPedido($cdfilial, $nrpedido, $observacao){
        try{
            $nrorg = Ambiente::getNrorg();
            $obspedido = Obspedido::findOneByNrorgAndCdfilialAndNrpedido($nrorg, $cdfilial, $nrpedido);
            if($obspedido){
                if($observacao <> NULL){
                    if($observacao <> $obspedido->getTxobsped()){
                        $obspedido->setTxobsped(bin2hex($observacao));
                        $obspedido->persist();
                    }
                }else{
                    $obspedido->delete();
                }
            }else{
                if($observacao <> NULL){
                    $obspedido = new Obspedido();
                    $obspedido->setNrorg($nrorg);
                    $obspedido->setCdfilial($cdfilial);
                    $obspedido->setNrpedido($nrpedido);
                    $obspedido->setTxobsped(bin2hex($observacao));
                    $obspedido->setDtinclusao(DateUtil::getDataAtual());
                    $obspedido->setDtultatu(DateUtil::getDataAtual());
                    $obspedido->setCdoperinclusao(Ambiente::getCdOperador());
                    $obspedido->setCdoperultatu(Ambiente::getCdOperador());
                    $obspedido->persist();
                }
            }
            Registry::getEntityManager()->flush();
        }catch(\Exception $e){
            throw $e;
        }
    }

}