create or replace 
PROCEDURE USR_IMP_CLIENTE
IS
   V_CDCLIENTE  VARCHAR2(20);
   V_NMRAZAOSOC VARCHAR2(40);
   V_NMFANTCLIE VARCHAR2(40);
   V_DSENDERECO VARCHAR2(40);
   V_CDPAIS     VARCHAR2(4);
   V_SGESTADO   VARCHAR2(2);
   V_CDMUNCIPIO VARCHAR2(7);
   V_CDCEP      VARCHAR2(15);
   V_NMBAIRRO   VARCHAR2(30);
   V_EMAIL      VARCHAR2(40);
   V_IDCLIEATIV VARCHAR2(1);
   V_CDCONTCTBL VARCHAR2(20);
   V_PAISPROT   VARCHAR2(4);
   V_ESTAPROT   VARCHAR2(2);
   V_MUNIPROT   VARCHAR2(7);
   V_CTBLPROT   VARCHAR2(20);
   V_MENSERRO   VARCHAR2(250);
   V_CLIENTE    VARCHAR2(21);
   V_IDINTERFAC VARCHAR2(1);
   V_TPIJURCLIE VARCHAR2(1);
   V_CLIEOUTROS VARCHAR2(20);
   
   CURSOR C_CLIENTE IS
      SELECT U.CDCLIENTE, U.NMRAZAOSOC, U.NMFANTCLIE, U.DSENDERECO, P.CDPAIS, E.SGESTADO, 
             M.CDMUNICIPIO, U.CDCEP, U.NMBAIRRO, U.EMAIL, U.IDCLIEATIV, C.CDCONTCTBL,
             U.CDPAIS CDPAIS_PROT, U.SGESTADO SGESTADO_PROT, U.CDMUNCIPIO CDMUNIC_PROT, U.CDCONTCTBL CONTCTBL_PROT,
             U.IDINTERFACE
        FROM USR_PROT_CLIENTE U LEFT OUTER JOIN PAIS P
                                             ON U.CDPAIS = P.CDPAIS
                                LEFT OUTER JOIN ESTADO E
                                             ON U.CDPAIS   = E.CDPAIS
                                            AND U.SGESTADO = E.SGESTADO
                                LEFT OUTER JOIN MUNICIPIO M
                                             ON U.CDPAIS     = M.CDPAIS
                                            AND U.SGESTADO   = M.SGESTADO
                                            AND U.CDMUNCIPIO = M.CDMUNICIBGE
                                LEFT OUTER JOIN CONTCTBL C
                                             ON U.CDCONTCTBL = C.CDCONTCTBL
       WHERE U.DTIMPORTACAO IS NULL
         AND U.LOG_ERRO IS NULL;
BEGIN
   OPEN C_CLIENTE;
   LOOP
      FETCH C_CLIENTE INTO V_CDCLIENTE, V_NMRAZAOSOC, V_NMFANTCLIE, V_DSENDERECO, V_CDPAIS, V_SGESTADO,
                           V_CDMUNCIPIO, V_CDCEP, V_NMBAIRRO, V_EMAIL, V_IDCLIEATIV, V_CDCONTCTBL,
                           V_PAISPROT, V_ESTAPROT, V_MUNIPROT, V_CTBLPROT, 
                           V_IDINTERFAC;
      EXIT WHEN C_CLIENTE%NOTFOUND;
      V_MENSERRO := NULL;
      
      IF (V_CDCONTCTBL IS NULL) THEN
         V_MENSERRO := 'Conta cont'||CHR(225)||'bil'||V_CTBLPROT||' n'||CHR(227)||'o cadastrado no sistema. ';
      END IF;
      
      BEGIN
         SELECT MIN(CDCLIENTE) AS CLIENTE
           INTO V_CLIENTE
           FROM CLIENTE
          WHERE REGEXP_LIKE (NRINSJURCLIE, '(^0*0|^)'||V_CDCLIENTE||'$');
         --'(^0*0|^)' -> verifica se existe um cliente com essa inscricao exata ou com 0(zeros) a esquerda da variavel "V_CDCLIENTE"
         --'$' -> Obriga terminar com o valor de V_CDCLIENTE
      EXCEPTION
         WHEN OTHERS THEN
            V_CLIENTE := NULL;               
      END;
      
      IF (V_CDPAIS IS NOT NULL) THEN
         IF (V_SGESTADO IS NOT NULL) THEN
            IF (V_CDMUNCIPIO IS NOT NULL) THEN
               IF (V_IDINTERFAC = '1') THEN
                  IF (V_CLIENTE IS NULL) THEN
                     IF (V_CDCONTCTBL IS NOT NULL) THEN
                        CASE
                           WHEN LENGTH(V_CDCLIENTE)<= 5  THEN V_TPIJURCLIE := 'O'; V_CLIEOUTROS := LPAD(V_CDCLIENTE, 5, '0');
                           WHEN LENGTH(V_CDCLIENTE) = 11 THEN V_TPIJURCLIE := 'F';
                           WHEN LENGTH(V_CDCLIENTE) = 14 THEN V_TPIJURCLIE := 'J';
                           ELSE V_TPIJURCLIE := 'I';
                        END CASE;
                        
                        V_CLIENTE := V_TPIJURCLIE||(CASE WHEN V_TPIJURCLIE = 'O' THEN V_CLIEOUTROS ELSE V_CDCLIENTE END);
                        
                        BEGIN
                           INSERT INTO CLIENTE(CDCLIENTE, IDTPIJURCLIE, NRINSJURCLIE, NMRAZSOCCLIE, NMFANTCLIE, IDCLIEATIV, CDCONTCTBL)
                           VALUES(V_CLIENTE, V_TPIJURCLIE, V_CDCLIENTE, V_NMRAZAOSOC, V_NMFANTCLIE, V_IDCLIEATIV, V_CDCONTCTBL);
                           
                           INSERT INTO ENDECLIE(CDCLIENTE, DSENDECLIE, CDPAIS, SGESTADO, CDMUNICIPIO, IDTPENDECLIE)
                           VALUES(V_CLIENTE, V_DSENDERECO, V_CDPAIS, V_SGESTADO, V_CDMUNCIPIO, 'P');
                        EXCEPTION
                           WHEN OTHERS THEN
                              V_MENSERRO := 'No foi possvel incluir o cliente. Ocorreu o erro: '||SQLERRM(SQLCODE);
                        END;
                     END IF;
                  ELSE
                     V_MENSERRO := 'Cliente j'||CHR(225)||' cadastrado no sistema.';
                  END IF;                  
               ELSIF (V_IDINTERFAC = '2') THEN
                  IF (V_CLIENTE IS NOT NULL) THEN
                     BEGIN
                        DELETE FROM CLIENTE
                         WHERE CDCLIENTE = V_CLIENTE;                        
                     EXCEPTION
                        WHEN OTHERS THEN
                           V_MENSERRO := 'No foi possvel excluir o cliente. Ocorreu o erro: '||SQLERRM(SQLCODE);
                     END;
                  ELSE
                     V_MENSERRO := 'Cliente n'||CHR(227)||'o cadastrado no sistema. ';
                  END IF;
               ELSE
                  IF (V_CLIENTE IS NOT NULL) THEN
                     IF (V_CDCONTCTBL IS NOT NULL) THEN
                        BEGIN
                           UPDATE CLIENTE
                              SET NMRAZSOCCLIE = V_NMRAZAOSOC,
                                  NMFANTCLIE   = V_NMFANTCLIE,
                                  IDCLIEATIV   = V_IDCLIEATIV,
                                  CDCONTCTBL   = V_CDCONTCTBL
                            WHERE CDCLIENTE = V_CLIENTE;
                            
                            UPDATE ENDECLIE
                               SET DSENDECLIE  = V_DSENDERECO,
                                   CDPAIS      = V_CDPAIS,
                                   SGESTADO    = V_SGESTADO,
                                   CDMUNICIPIO = V_CDMUNCIPIO,
                                   NRCEPCLIE   = V_CDCEP,
                                   NMBAIRCLIE  = V_NMBAIRRO,
                                   DSEMAILCLIE = V_EMAIL
                             WHERE CDCLIENTE  = V_CLIENTE
                               AND IDTPENDECLIE = 'P';
                        EXCEPTION
                           WHEN OTHERS THEN
                              V_MENSERRO := 'No foi possvel alterar o cadastro de cliente. Ocorreu o erro: '||SQLERRM(SQLCODE);
                        END;
                     END IF;
                  ELSE
                     V_MENSERRO := 'Cliente n'||CHR(227)||'o cadastrado no sistema. ';
                  END IF;
               END IF;
            ELSE
               V_MENSERRO := V_MENSERRO||'C'||CHR(243)||'digo do munic'||CHR(237)||'pio '||V_MUNIPROT||' n'||CHR(227)||'o cadastrado no sistema. ';
            END IF;
         ELSE
            V_MENSERRO := V_MENSERRO||'Sigla do estado '||V_ESTAPROT||' n'||CHR(227)||'o cadastrado no sistema.';
         END IF;
      ELSE
         V_MENSERRO := V_MENSERRO||'C'||CHR(243)||'digo do pa'||CHR(237)||'s '||V_PAISPROT||' n'||CHR(227)||'o cadastrado no sistema. ';
      END IF;
      
      /* E SE HOUVER MAIS DE UM CLIENTE COM O MESMO CDIGO NA TABELA INTERMEDIRIA? */
      IF (V_MENSERRO IS NOT NULL) THEN
         UPDATE USR_PROT_CLIENTE
            SET STATUS   = 'E',
                LOG_ERRO = V_MENSERRO
          WHERE CDCLIENTE = V_CDCLIENTE;
      ELSE
         UPDATE USR_PROT_CLIENTE
            SET DTIMPORTACAO = SYSDATE,
                HRIMPORTACAO = TO_CHAR(SYSDATE, 'HH24:MI')
          WHERE CDCLIENTE = V_CDCLIENTE;
      END IF;
   END LOOP;
   
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      V_MENSERRO := SQLERRM(SQLCODE);
      UPDATE USR_PROT_CLIENTE
         SET STATUS   = 'E',
             LOG_ERRO = V_MENSERRO
       WHERE CDCLIENTE = V_CDCLIENTE;
      
      COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('TABELAS_INT_PROT','5.85.XXX'); END;
/