/*************************************************************************************************/
/*                                                                                               */
/* Trigger: DTULTATU_MOTIVOTRAM                                                                  */
/* Tabela : MOTITRAMITACAO                                                                       */
/*                                                                                               */
/* Criao:                                                                                      */
/* 05/11/2008 - GLEYDSON ISRAEL DA SILVA GAZOLA                                                  */
/*                                                                                               */
/*************************************************************************************************/


IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_MOTIVOTRAM' and
            type = 'TR'                    and
            u.uid = o.uid                  and
            u.name = USER)
   DROP TRIGGER DTULTATU_MOTIVOTRAM
GO

CREATE TRIGGER DTULTATU_MOTIVOTRAM
ON MOTITRAMITACAO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'MOTITRAMITACAO', 'CDMOTITRAMITA=' + CDMOTITRAMITA+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE MOTITRAMITACAO
      SET  DTULTATUMOTITRA = GETDATE()
      FROM INSERTED
      WHERE ISNULL(MOTITRAMITACAO.CDMOTITRAMITA,0) = ISNULL(INSERTED.CDMOTITRAMITA,0);
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_MOTIVOTRAM','0.00.000';
GO