/* Sistemas Integrados TEKNISA
Importao de notas fiscais

Nome: 0002_SESSTRS_SES_NOTAFISCAL.SQL

Descrio:
   Criao das tabelas referentes  importao de notas fiscais para os sistemas Teknisa, 
especficas do cliente Sesi.

Criao:
29/04/2011 - Jefferson de Melo Gouvea
*/

CREATE TABLE USR_NOTAFISCAL
(
	CDCHAVE						VARCHAR(20)			not null,
	CDFILIAL						VARCHAR(04)			not null,
	CDEMPRESA					VARCHAR(02)			not null,
	NRINSJURNF					VARCHAR(20)			not null,
	NRNOTAFISC					VARCHAR(20)			null,
	DTEMISSAO					DATE					null,
	DTENTRSAID					DATE					not null,
	IDENTRSAIDOP				VARCHAR(01)			not null
		constraint CKC_SES_IDENTRSAIDOP check (IDENTRSAIDOP in ('E','S')),
	CDTIPOOPER					VARCHAR(02)			not null,
	CDSERIE						VARCHAR(05)			not null,
	CDMODDOCFISC				VARCHAR(02)			not null,
	CDFILIEMIT					VARCHAR(04)			null,
	CDFILIRECE					VARCHAR(04)			null,
	DTIMPORTA					DATE					null,
	DSOBSERVERROS				VARCHAR(1000)		null,
		constraint PK_USR_NOTAFISCAL primary key (CDCHAVE)
)
GO

CREATE TABLE USR_ITEMPRODUTO
(
	CDCHAVE				VARCHAR(20)				not null,
	CDFILIAL				VARCHAR(04)				not null,
	CDPRODUTO			VARCHAR(20)				not null,
	QTITEMPROD			FLOAT						not null,
	VRUNITITEM			FLOAT						not null,
	VRDESCITEM			FLOAT						null,
	VRTOTAITEM			FLOAT						not null,
	CDFISOPEITEM		VARCHAR(11)				null,
	CDSITUTRIBPR		VARCHAR(03)				null,
	CDALMOXARIFE		VARCHAR(06)				null,
	CDLOCALESTOQ		VARCHAR(06)				null,
	NRLOTEESTQ			VARCHAR(20)				null,
	NRSUBLOTE			VARCHAR(04)				null,
	DSOBSERVERROS		VARCHAR(400)			null,
		constraint PK_USR_ITEMPRODUTO primary key (CDCHAVE, CDPRODUTO)
)
GO

CREATE TABLE USR_ITEMENCARGO
(
	CDCHAVE				VARCHAR(20)				not null,
	CDFILIAL				VARCHAR(04)				not null,
	CDENCARGO			VARCHAR(02)				not null,
	VRITEMENCA			FLOAT						not null,
	DSOBSERVERROS		VARCHAR(400)			null,
		constraint PK_USR_ITEMENCARGO primary key (CDCHAVE, CDENCARGO)
)
GO

ALTER TABLE NOTAFISCAL ADD SES_CDCHAVE VARCHAR(20) NULL
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZACAO_ESTRUTURA_BD','5.11.000';
GO
